<section class="content-header">
  <div class="form-group float-right mt-2 mb-1">
    <button type="button" (click)="open(confirm_submit_modal)" class="btn btn-primary btn-flat btn-sm">
      <span class="fa fa-save"></span>
      &nbsp;Submit
    </button>
  </div>
</section>

<section class="content">
  <p>{{ time_remaining | countdown:hours:minutes:seconds }}</p>


  <ul class="nav nav-tabs">
    <li *ngIf="QEH?.has_multiple_choice" [ngClass]="{'active show':current_tab === TYPE.mc}" class="nav-item">
      <a class="nav-link px-2 small" (click)="changeTab(TYPE.mc)" href="#mc" role="tab" data-toggle="tab">Multiple choice</a>
    </li>
    <li *ngIf="QEH?.has_identification" [ngClass]="{'active show':current_tab === TYPE.id}" (click)="changeTab(TYPE.id)" class="nav-item">
      <a class="nav-link px-2 small" href="#id" role="tab" data-toggle="tab">Identification</a>
    </li>
    <li *ngIf="QEH?.has_enumeration" [ngClass]="{'active show':current_tab === TYPE.en}" (click)="changeTab(TYPE.en)" class="nav-item">
      <a class="nav-link px-2 small" href="#en" role="tab" data-toggle="tab">Enumeration</a>
    </li>
    <li *ngIf="QEH?.has_true_false" [ngClass]="{'active show':current_tab === TYPE.tf}" (click)="changeTab(TYPE.tf)" class="nav-item">
      <a class="nav-link px-2 small" href="#tf" role="tab" data-toggle="tab">True or False</a>
    </li>
    <li *ngIf="QEH?.has_essay" [ngClass]="{'active show':current_tab === TYPE.es}" (click)="changeTab(TYPE.es)" class="nav-item">
      <a class="nav-link px-2 small" href="#ess" role="tab" data-toggle="tab">Essay</a>
    </li>
  </ul>

  <div class="tab-content bg-white border border-top-0">

    <div *ngIf="QEH?.has_multiple_choice && current_tab === TYPE.mc" [ngClass]="{'active show':current_tab === TYPE.mc}" role="tabpanel"
      class="tab-pane fade in" id="mc">
      <div class="row justify-content-center">

        <ng-container *ngFor="let q of multiple_choice; index as i">
          <div class="col-md-9 pt-4 d-none" [ngClass]="{'d-inline' : (mc_page === i) }">
            <strong>Question {{i+1}}</strong>
            <p>{{ q.question }}</p>
            <div class="form-group">
              <div class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="mc-{{q.id}}" [(ngModel)]="q.answer" [value]="'a'"> <strong>&nbsp;a.</strong>
                  {{ q.a }}
                </label>
              </div>
              <div class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="mc-{{q.id}}" [(ngModel)]="q.answer" [value]="'b'"> <strong>&nbsp;b.</strong>
                  {{ q.b }}
                </label>
              </div>
              <div class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="mc-{{q.id}}" [(ngModel)]="q.answer" [value]="'c'"> <strong>&nbsp;c.</strong>
                  {{ q.c }}
                </label>
              </div>
              <div *ngIf="q.d" class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="mc-{{q.id}}" [(ngModel)]="q.answer" [value]="'d'"> <strong>&nbsp;d.</strong>
                  {{ q.d }}
                </label>
              </div>
              <div *ngIf="q.e" class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="mc-{{q.id}}" [(ngModel)]="q.answer" [value]="'e'"> <strong>&nbsp;e.</strong>
                  {{ q.e }}
                </label>
              </div>
            </div>
            <div class="form-row justify-content-center mb-4">
              <button type="button" [disabled]="i === 0" (click)="goto(TYPE.mc, i-1, q)">Prev</button>
              <button type="button" (click)="goto(TYPE.mc, i+1, q)">{{ getNextPrev(i,multiple_choice.length,1) }}</button>
            </div>
          </div>
        </ng-container>

      </div>
    </div>

    <div *ngIf="QEH?.has_identification && current_tab === TYPE.id" [ngClass]="{'active show':current_tab === TYPE.id}" role="tabpanel"
      class="tab-pane fade in" id="id">
      <div class="row justify-content-center">

        <ng-container *ngFor="let q of identification; index as i">
          <div class="col-md-9 pt-4 d-none" [ngClass]="{'d-inline' : (id_page === i) }">
            <strong>Question {{i+1}}</strong>
            <p>{{ q.question }}</p>
            <div class="form-row justify-content-center mb-4">
              <div class="col-md-9">
                <label for="id-{{q.id}}" class="control-label mb-1">Answer</label>
                <input type="text" name="id-{{q.id}}" [(ngModel)]="q.answer" class="form-control form-control-sm">
              </div>
            </div>
            <div class="form-row justify-content-center mb-4">
              <button type="button" [disabled]="i === 0" (click)="goto(TYPE.id, i-1, q)">Prev</button>
              <button type="button" (click)="goto(TYPE.id, i+1, q)">{{ getNextPrev(i,identification.length,1) }}</button>
            </div>
          </div>
        </ng-container>

      </div>
    </div>

    <div *ngIf="QEH?.has_enumeration && current_tab === TYPE.en" [ngClass]="{'active show':current_tab === TYPE.en}" role="tabpanel"
      class="tab-pane fade in" id="en">
      <div class="row justify-content-center">

        <ng-container *ngFor="let q of enumeration; index as i;">
          <div class="col-md-9 pt-4 d-none" [ngClass]="{'d-inline' : (en_page === i) }">
            <strong>Question {{i+1}}</strong>
            <p>{{ q.question }}</p>
            <div *ngFor="let ans of q.total_answers | createArray; index as a" class="form-row justify-content-center">
              <div class="col-md-9 mb-2">
                <label for="enum-{{q.id}}-{{a}}" class="control-label mb-1">Answer {{ a+1 }}</label>
                <input type="text" name="enum-{{q.id}}-{{a}}" [(ngModel)]="q.answers_arr[a]" class="form-control form-control-sm">
              </div>
            </div>
            <div class="form-row justify-content-center mb-4 mt-4">
              <button type="button" [disabled]="i === 0" (click)="goto(TYPE.en, i-1, q)">Prev</button>
              <button type="button" (click)="goto(TYPE.en, i+1, q)">{{ getNextPrev(i,enumeration.length,1) }}</button>
            </div>
          </div>
        </ng-container>

      </div>
    </div>

    <div *ngIf="QEH?.has_true_false && current_tab === TYPE.tf" [ngClass]="{'active show':current_tab === TYPE.tf}" role="tabpanel"
      class="tab-pane fade in" id="tf">
      <div class="row justify-content-center">

        <ng-container *ngFor="let q of true_false; index as i">
          <div class="col-md-9 pt-4 d-none" [ngClass]="{'d-inline' : (tf_page === i) }">
            <strong>Question {{i+1}}</strong>
            <p>{{ q.question }}</p>
            <div class="form-group">
              <div class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="tf-{{q.id}}" [(ngModel)]="q.answer" [value]="1"> True
                </label>
              </div>
              <div class="form-check">
                <label class="form-check-label">
                  <input type="radio" class="form-check-input" name="tf-{{q.id}}" [(ngModel)]="q.answer" [value]="0"> False
                </label>
              </div>
            </div>
            <div class="form-row justify-content-center mb-4">
              <button type="button" [disabled]="i === 0" (click)="goto(TYPE.tf, i-1, q)">Prev</button>
              <button type="button" (click)="goto(TYPE.tf, i+1, q)">{{ getNextPrev(i,true_false.length,1) }}</button>
            </div>
          </div>
        </ng-container>

      </div>
    </div>

    <div *ngIf="QEH?.has_essay && current_tab === TYPE.es" [ngClass]="{'active show':current_tab === TYPE.es}" role="tabpanel"
      class="tab-pane fade in" id="ess">
      <div class="row justify-content-center">

        <ng-container *ngFor="let q of essay; index as i">
          <div class="col-md-9 pt-4 d-none" [ngClass]="{'d-inline' : (es_page === i) }">
            <strong>Question {{i+1}}</strong>
            <p>{{ q.question }}</p>
            <div class="form-group">
              <div class="radio">
                <label>Answer </label>
                <textarea name="ess-answer-{{i}}" class="form-control form-control-sm" rows="10" [(ngModel)]="q.answer"></textarea>
              </div>
            </div>
            <div class="form-row justify-content-center mb-4">
              <button type="button" [disabled]="i === 0" (click)="goto(TYPE.es, i-1, q)">
                {{ getNextPrev(i,essay.length,0) }}
              </button>
              <button type="button" (click)="goto(TYPE.es, i+1, q)">{{ getNextPrev(i,essay.length,1) }}</button>
            </div>
          </div>

        </ng-container>

      </div>
    </div>

  </div>
</section>

<ng-template #content let-modal let-c="close">

  <div class="modal-header">
    <h4 class="modal-title">Start</h4>
  </div>
  <div class="modal-body">

  </div>
  <div class="modal-footer">
    <div class="form-group float-right mt-2 mb-1">
      <button type="button" (click)="start()" class="btn btn-primary btn-flat btn-sm">
        <span class="fa fa-hourglass-start" [ngClass]="{'fa-spin' : loading}"></span>
        &nbsp;Start
      </button>
      <button type="button" (click)="cancel()" class="btn btn-danger btn-flat btn-sm">
        <span class="fa fa-times"></span>
        Cancel
      </button>
    </div>
  </div>
</ng-template>

<ng-template #view_result_modal let-modal let-c="close">

  <div class="modal-header">
    <h4 class="modal-title" *ngIf="isTimeUp()">Time's up!!!</h4>
    <h4 class="modal-title" *ngIf="!isTimeUp()">Submit successful</h4>
  </div>
  <div class="modal-body">
    <p *ngIf="isTimeUp()">QEH has been submitted.</p>
  </div>
  <div class="modal-footer">
    <div class="form-group float-right mt-2 mb-1">
      <button type="button" class="btn btn-sm" (click)="view_result()">View result</button>
    </div>
  </div>

</ng-template>

<ng-template #confirm_submit_modal let-modal let-c="close">

  <div class="modal-header">
    <h4 class="modal-title">Submit QEH?</h4>
  </div>
  <div class="modal-footer">
    <div class="form-group float-right mt-2 mb-1">
      <button type="button" class="btn btn-sm btn-flat btn-primary" (click)="submit()">
        <span class="fa fa-check"></span> Yes
      </button>
      <button type="button" class="btn btn-sm btn-flat btn-danger" (click)="c()">
        <span class="fa fa-times"></span> No
      </button>
    </div>
  </div>

</ng-template>